; Window fade in & out example, adapted from the tutorial available at 
; http://www.codeproject.com/dialog/smoothalpha.asp by Mark Jones 2006

include masm32rt.inc    ; standard MASM32v9+ compile-time libs

DlgProc         PROTO :HWND,:UINT,:WPARAM,:LPARAM
FadeIn          PROTO                       ; must be defined for callback
FadeOut         PROTO

.const
AnimationTime           dd 2000             ; fade duration, in ms
FinalAlpha              dd 200              ; maximum opacity
Win2k                   db "Windows 2000 or greater is required!",0

.data?
hInstance               dd ?
hWnd                    dd ?
hTimer                  dd ?
UpTime                  dd ?                ; system up-time
Alpha                   dd ?                ; working opacity

.code
start:
    invoke GetModuleHandle,0
    mov hInstance,eax
;    invoke InitCommonControls
    invoke DialogBoxParam,hInstance,101,0,addr DlgProc,0
    invoke ExitProcess,0


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
    .if eax==WM_INITDIALOG
        m2m hWnd,hWin
        invoke GetWindowLong,hWnd,GWL_EXSTYLE   ; get window extended style
        or eax,WS_EX_LAYERED                    ; add the layered bit
        invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
        .if eax==0                              ; if failure,
            invoke MessageBox,hWnd,addr Win2k,0,MB_OK
            invoke EndDialog,hWnd,0
        .endif
        invoke SetLayeredWindowAttributes,hWin,0,0,LWA_ALPHA
;        invoke ShowWindow,hWin,SW_SHOW
;        invoke RedrawWindow,hWin,0,0,RDW_UPDATENOW
        invoke GetTickCount
        mov UpTime,eax                          ; current time in UpTime
        call FadeIn                             ; begin fade-in
    .elseif eax==WM_COMMAND
    .elseif eax==WM_CLOSE
        invoke GetTickCount
        mov UpTime,eax
        call FadeOut
    .else
        mov eax,0
        ret
    .endif
    mov eax,1
    ret
DlgProc endp


stackframe off
align 16
FadeIn PROC
    invoke KillTimer,0,hTimer                   ; disable timer
; Alpha = (TimeElapsed * FinalAlpha) / AnimationTime    
    invoke GetTickCount                         ; current time in eax
    sub eax,UpTime                              ; elapsed time in eax
    cmp eax,AnimationTime                       ; have we reached our limit?
    jae @F                                      ; if so don't reset timer
    mul FinalAlpha                              ; multiply eax by target opacity
    div AnimationTime                           ; divide eax by total time
    cmp eax,FinalAlpha                          ; alpha limit?
    jae @F                                      ; if so, exit
    invoke SetLayeredWindowAttributes,hWnd,0,eax,LWA_ALPHA
    invoke SetTimer,0,0,10,addr FadeIn          ; else run again in 10ms
    mov hTimer,eax
@@: ret
FadeIn endp

align 16
FadeOut proc
    invoke KillTimer,0,hTimer
; Alpha = (TimeRemaining * FinalAlpha) / AnimationTime
    invoke GetTickCount
    sub eax,UpTime
    m2m ecx,eax                                 ; elapsed time in ecx
    mov eax,AnimationTime                       ; total time in eax
    sub eax,ecx                                 ; time left in eax
    cmp eax,0                                   ; have we reached the end?
    jle @F                                      ; if so, terminate
    mul FinalAlpha
    div AnimationTime
    invoke SetLayeredWindowAttributes,hWnd,0,eax,LWA_ALPHA
    invoke SetTimer,0,0,10,addr FadeOut
    mov hTimer,eax
    ret
@@: invoke EndDialog,hWnd,0
FadeOut endp
stackframe on


end start
